
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import java.io.Writer;
import java.io.IOException;

public class CharsetServlet extends HttpServlet {
    String jettyCharset, requestEncoding;

    protected void service(HttpServletRequest request, HttpServletResponse response) throws IOException {
        if (requestEncoding != null)
            request.setCharacterEncoding(requestEncoding);

        String tmp = request.getParameter("note");
        String tmp1 = new String(tmp.getBytes("ISO-8859-1")); // this is correct for request locale cs
        String tmp2 = new String(tmp.getBytes("ISO-8859-2"));
        String tmp3 = new String(tmp.getBytes("UTF-8"));

        response.setContentType("text/html; charset=ISO-8859-2");
        Writer w = response.getWriter();
        w.write("<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-2\"></head><body>");
        w.write("parameter has value: " + tmp + "<br>");
        w.write("parameter.getBytes(\"ISO-8859-1\") has value: " + tmp1 + "<br>");
        w.write("parameter.getBytes(\"ISO-8859-2\") has value: " + tmp2 + "<br>");
        w.write("parameter.getBytes(\"UTF-8\") has value: " + tmp3 + "<br>");
        w.write("expected value: \u017E\u00ED\u017Eala");
        w.write("</body></html>");
    }

    public void init(ServletConfig servletConfig) throws ServletException {
        jettyCharset = servletConfig.getInitParameter("jettyCharset");
        if (jettyCharset != null)
            System.setProperty("org.mortbay.util.URI.charset", jettyCharset);
        requestEncoding = servletConfig.getInitParameter("requestEncoding");
    }
}
